/******************************************************************************/
/* CD_DISP.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_struc.h"
#include "st_aes.h"
#include "cd_bind.h"
#include "cd_disp.h"

/* -------------------------------------------------------------------------- */

extern	int	gl_charwide;
extern	int	gl_scrhandle;

extern	CDROM	*gl_actdocu;

extern	GRECT	cd_titlrect;
extern	GRECT	cd_inforect;
extern	GRECT	cd_headrect;
extern	GRECT	cd_datarect;

extern	int	cd_titloffs;
extern	int	cd_infooffs;
extern	int	cd_headoffs;

extern	int	cd_sizestartx;
extern	int	cd_stimstartx;
extern	int	cd_etimstartx;
extern	int	cd_commstartx;

extern	long	cd_visx;
extern	long	cd_visy;

extern	unsigned int	cd_evnlinetype;
extern	unsigned int	cd_oddlinetype;

extern	ITEM	*cd_inv_item;

/* -------------------------------------------------------------------------- */

static	int	cd_sessno;
static	int	cd_trakno;
static	int	cd_itemno;

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_display_title(drawrect)
register GRECT	*drawrect;
{
register int	rasx;
register int	rasy;
int	junk;
int	pxy[4];
GRECT	a;

	if (!st_intersect(drawrect, &cd_titlrect, &a))
		return;

	st_v_clip_boxon(&a);
	st_mouse_hide();

/* clear the title row */

	pxy[0] = cd_titlrect.g_x;
	pxy[1] = cd_titlrect.g_y;
	pxy[2] = cd_titlrect.g_x + cd_titlrect.g_w - 1;
	pxy[3] = cd_titlrect.g_y + cd_titlrect.g_h - 1;
	v_bar(gl_scrhandle, pxy);

/* draw a horizontal line below the title row */

	pxy[1] = pxy[3];
	v_pline(gl_scrhandle, 2, pxy);

/* display the title */

	rasx = cd_titlrect.g_x + cd_titlrect.g_w / 2;
	rasy = cd_titlrect.g_y + cd_titlrect.g_h - 1 - cd_titloffs;

	vst_alignment(gl_scrhandle, 1, 0, &junk, &junk);
	vst_color(gl_scrhandle, DISP_TITLCOLOR);

	v_gtext(gl_scrhandle, rasx, rasy, gl_actdocu->CdRomName);

	vst_color(gl_scrhandle, DISP_DEFFCOLOR);
	vst_alignment(gl_scrhandle, 0, 0, &junk, &junk);

	st_mouse_show();
	st_v_clip_boxoff(&a);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_select_title()
{
int	pxy[4];

	pxy[0] = cd_titlrect.g_x;
	pxy[1] = cd_titlrect.g_y;
	pxy[2] = cd_titlrect.g_x + cd_titlrect.g_w - 1;
	pxy[3] = cd_titlrect.g_y + cd_titlrect.g_h - 2;

	st_v_clip_boxon(&cd_titlrect);
	vswr_mode(gl_scrhandle, MD_XOR);
	vsf_color(gl_scrhandle, BLACK);
	st_mouse_hide();

	vr_recfl(gl_scrhandle, pxy);

	st_mouse_show();
	vswr_mode(gl_scrhandle, MD_REPLACE);
	vsf_color(gl_scrhandle, WHITE);
	st_v_clip_boxoff(&cd_titlrect);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_display_info(drawrect)
register GRECT	*drawrect;
{
int	pxy[4];
GRECT	a;

	if (!st_intersect(drawrect, &cd_inforect, &a))
		return;

/* clear the information row */

	st_v_clip_boxon(&a);
	st_mouse_hide();

	pxy[0] = cd_inforect.g_x;
	pxy[1] = cd_inforect.g_y;
	pxy[2] = cd_inforect.g_x + cd_inforect.g_w - 1;
	pxy[3] = cd_inforect.g_y + cd_inforect.g_h - 1;
	v_bar(gl_scrhandle, pxy);

/* draw a horizontal line below the information bar */

	pxy[1] = pxy[3];
	v_pline(gl_scrhandle, 2, pxy);

	st_mouse_show();
	st_v_clip_boxoff(&a);

/* display the information in the row */

	cd_disp_info(&a);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_disp_info(drawrect)
register GRECT	*drawrect;
{
register CDROM	*docu = gl_actdocu;
register int	i;
register int	rasx;
register int	rasy;
unsigned char	mess[200];

	st_v_clip_boxon(drawrect);
	st_mouse_hide();

	sprintf(mess, st_freestr(FR_INFORMATION), docu->NoSessions, docu->NoTracks, docu->NoItems);
	for (i = (int)strlen(mess) ; i < 52 ; i++) mess[i] = ' ';
	mess[i] = '\0';

	rasx = cd_inforect.g_x + gl_charwide;
	rasy = cd_inforect.g_y + cd_inforect.g_h - 1 - cd_infooffs;

	vst_color(gl_scrhandle, DISP_INFOCOLOR);
	v_gtext(gl_scrhandle, rasx, rasy, mess);
	vst_color(gl_scrhandle, DISP_DEFFCOLOR);

	st_mouse_show();
	st_v_clip_boxoff(drawrect);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_display_header(drawrect)
register GRECT	*drawrect;
{
register int	offx;
register int	rasy;
int	junk;
int	pxy[4];
GRECT	a;

	if (!st_intersect(drawrect, &cd_headrect, &a))
		return;

/* clear the field header row */

	st_v_clip_boxon(&a);
	st_mouse_hide();

	pxy[0] = cd_headrect.g_x;
	pxy[1] = cd_headrect.g_y;
	pxy[2] = cd_headrect.g_x + cd_headrect.g_w - 1;
	pxy[3] = cd_headrect.g_y + cd_headrect.g_h - 1;
	v_bar(gl_scrhandle, pxy);

/* draw a horizontal line below the field header row */

	pxy[1] = pxy[3];
	v_pline(gl_scrhandle, 2, pxy);

/* draw different field header deviders and field headers */

	vst_alignment(gl_scrhandle, 1, 0, &junk, &junk);
	vst_color(gl_scrhandle, DISP_HEADCOLOR);

	pxy[1] = cd_headrect.g_y;
	rasy = cd_headrect.g_y + cd_headrect.g_h - 1 - cd_headoffs;

	offx = cd_headrect.g_x - (int)cd_visx - 1;
	pxy[2] = offx + cd_sizestartx;

	pxy[0] = pxy[2];
	v_pline(gl_scrhandle, 2, pxy);
	pxy[2] = offx + cd_stimstartx;
	v_gtext(gl_scrhandle, (pxy[0] + pxy[2])/2, rasy, st_freestr(FR_SIZE));

	pxy[0] = pxy[2];
	v_pline(gl_scrhandle, 2, pxy);
	pxy[2] = offx + cd_etimstartx;
	v_gtext(gl_scrhandle, (pxy[0] + pxy[2])/2, rasy, st_freestr(FR_STARTTIME));

	pxy[0] = pxy[2];
	v_pline(gl_scrhandle, 2, pxy);
	pxy[2] = offx + cd_commstartx;
	v_gtext(gl_scrhandle, (pxy[0] + pxy[2])/2, rasy, st_freestr(FR_ENDTIME));

	vst_alignment(gl_scrhandle, 0, 0, &junk, &junk);

	pxy[0] = pxy[2];
	v_pline(gl_scrhandle, 2, pxy);
	v_gtext(gl_scrhandle, pxy[0] + gl_charwide, rasy, st_freestr(FR_COMMENT));

	vst_color(gl_scrhandle, DISP_DEFFCOLOR);
	st_mouse_show();
	st_v_clip_boxoff(&a);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_display(drawrect)
register GRECT	*drawrect;
{
register ITEM	*item;
register long	liny;
register long	miny;
register long	maxy;
int	pxy[4];
GRECT	a;

	if (!st_intersect(drawrect, &cd_datarect, &a))
		return;

	miny = (long)(a.g_y - cd_datarect.g_y) + cd_visy;
	maxy = miny + (long)(a.g_h - 1);

	liny = 0;
	for (item = gl_actdocu->FirstItem ; item ; item = item->next)
	{
		liny += item->Hite;
		if (liny > miny)	cd_display_item(item, &a);
		if (liny > maxy)	break;
	}
	if (item != NULL)
		return;

	st_v_clip_boxon(&a);
	st_mouse_hide();

	pxy[0] = a.g_x;
	pxy[2] = a.g_x + a.g_w - 1;

	pxy[1] = a.g_y + (int)(liny - miny);
	pxy[3] = a.g_y + a.g_h - 1;
	v_bar(gl_scrhandle, pxy);

	st_mouse_show();
	st_v_clip_boxoff(&a);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_select(drawrect)
register GRECT	*drawrect;
{
register ITEM	*item;
register long	liny;
register long	miny;
register long	maxy;
GRECT	a;

	if (!st_intersect(drawrect, &cd_datarect, &a))
		return;

	miny = (long)(a.g_y - cd_datarect.g_y) + cd_visy;
	maxy = miny + (long)(a.g_h - 1);

	liny = 0L;
	for (item = gl_actdocu->FirstItem ; item ; item = item->next)
	{
		liny += item->Hite;
		if (liny > miny)	cd_select_item(item, &a);
		if (liny > maxy)	break;
	}
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_currsel(drawrect)
register GRECT	*drawrect;
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item = docu->SelItem;
register long	liny;
register int	rasy;
register int	hite;
int	pxy[4];
int	xy[4];

	liny = cd_y_coordinate(item) - cd_visy;
	hite = item->Hite;

	if ((liny < 0L) || (liny > (cd_datarect.g_h + hite)))
		return;

	rasy = cd_datarect.g_y + (int)liny;

	pxy[0] = cd_datarect.g_x + item->StartX - (int)cd_visx;
	pxy[2] = cd_datarect.g_x + cd_datarect.g_w - 1;

	pxy[1] = rasy - hite;
	pxy[3] = rasy - 1;

	st_v_clip_boxon(drawrect);
	vswr_mode(gl_scrhandle, MD_XOR);
	st_mouse_hide();

	pxy[0] += 2;
	pxy[2] += 2;

	pxy[1] += 1;
	pxy[3] -= 2;

	xy[0] = pxy[0];
	xy[2] = pxy[2];

	xy[1] = xy[3] = pxy[1];
	v_pline(gl_scrhandle, 2, xy);
	xy[1] = xy[3] = pxy[1] - 1;
	v_pline(gl_scrhandle, 2, xy);

	xy[1] = xy[3] = pxy[3];
	v_pline(gl_scrhandle, 2, xy);
	xy[1] = xy[3] = pxy[3] + 1;
	v_pline(gl_scrhandle, 2, xy);

	xy[1] = pxy[1] - 1;
	xy[3] = pxy[3] + 1;
	xy[0] = xy[2] = pxy[0] - 1;
	v_pline(gl_scrhandle, 2, xy);
	xy[1] += 2;
	xy[3] -= 2;
	xy[0] = xy[2] = pxy[0];
	v_pline(gl_scrhandle, 2, xy);

	st_mouse_show();
	vswr_mode(gl_scrhandle, MD_REPLACE);
	st_v_clip_boxoff(drawrect);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_display_str(item, mess)
register ITEM	*item;
register unsigned char	mess[];
{
register unsigned int	settings = item->Settings;

	     if (settings & IT_SESSION)	sprintf(mess, st_freestr(FR_SESSION), cd_sessno);
	else if (settings & IT_TRACK)	sprintf(mess, st_freestr(FR_TRACK), cd_trakno);
	else if (settings & IT_ITEM)	strcpy(mess, st_str_filename(item->PathName));
	else if (settings & IT_LAST)	strcpy(mess, st_freestr(FR_LASTLINE));
	else				strcpy(mess, "");
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_display_color(item)
ITEM	*item;
{
register unsigned int	settings;
register int	color;

	if (item == NULL)
	{
		color = DISP_DEFFCOLOR;
	}
	else
	{
		settings = item->Settings;

		     if (settings & IT_LAST)	color = DISP_LASTCOLOR;
		else if (settings & IT_SESSION)	color = DISP_SESSCOLOR;
		else if (settings & IT_TRACK)	color = DISP_TRAKCOLOR;
		else if (settings & IT_ITEM)	color = DISP_ITEMCOLOR;
	}
	vst_color(gl_scrhandle, color);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_display_framestr(nofrms, s)
register unsigned long	nofrms;
unsigned char	s[];
{
register int	mins, secs, frms;

	mins = (int)(nofrms / MAX_MINSIZE);
	nofrms %= MAX_MINSIZE;
	secs = (int)(nofrms / MAX_SECSIZE);
	nofrms %= MAX_SECSIZE;
	frms = (int)(nofrms);
	sprintf(s, "%02d:%02d:%02d", mins, secs, frms);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_display_item(item, drawrect)
register ITEM	*item;
register GRECT	*drawrect;
{
register long	liny;
register int	hite;
register int	rasx;
register int	rasy;
register int	offx;
int	pxy[4];
unsigned char	mess[200];

	liny = cd_y_coordinate(item) - cd_visy;
	hite = item->Hite;

	if ((liny < 0L) || (liny > (cd_datarect.g_h + hite)))
		return;

/* clear the current row */

	st_v_clip_boxon(drawrect);
	st_mouse_hide();

	rasx = cd_datarect.g_x + item->StartX - (int)cd_visx;
	rasy = cd_datarect.g_y + (int)liny;

	pxy[0] = cd_datarect.g_x;
	pxy[2] = cd_datarect.g_x + cd_datarect.g_w - 1;

	pxy[1] = rasy - hite;
	pxy[3] = rasy - 1;
	v_bar(gl_scrhandle, pxy);

/* draw a horizontal line below the current row */

	pxy[1] = pxy[3];
	v_pline(gl_scrhandle, 2, pxy);

/* draw a vertical line at the begining of current row */

	pxy[0] = pxy[2] = rasx;
	pxy[1] = rasy - hite;
	v_pline(gl_scrhandle, 2, pxy);

/* display the row header */

	cd_display_str(item, mess);
	cd_display_color(item);

	rasx += gl_charwide;
	rasy -= item->OffsetY;
	v_gtext(gl_scrhandle, rasx, rasy, mess);

	if (item->Settings & IT_LAST)
	{
		cd_display_color(NULL);
		st_mouse_show();
		st_v_clip_boxoff(drawrect);
		return;
	}

/* display different field deviders and field information */

	offx = cd_datarect.g_x - (int)cd_visx - 1;

	pxy[0] = pxy[2] = offx + cd_sizestartx;
	v_pline(gl_scrhandle, 2, pxy);

	if (item->Settings & IT_ITEM)
	{
		sprintf(mess, "%9ld", item->Length);
		v_gtext(gl_scrhandle, pxy[0] + gl_charwide, rasy, mess);
	}

	pxy[0] = pxy[2] = offx + cd_stimstartx;
	v_pline(gl_scrhandle, 2, pxy);

	if (item->Settings & (IT_SESSION | IT_TRACK | IT_ITEM))
	{
		cd_display_framestr(item->FrameStart, mess);
		v_gtext(gl_scrhandle, pxy[0] + gl_charwide, rasy, mess);
	}

	pxy[0] = pxy[2] = offx + cd_etimstartx;
	v_pline(gl_scrhandle, 2, pxy);

	if (item->Settings & (IT_SESSION | IT_TRACK | IT_ITEM))
	{
		cd_display_framestr(item->FrameLength, mess);
		v_gtext(gl_scrhandle, pxy[0] + gl_charwide, rasy, mess);
	}

	pxy[0] = pxy[2] = offx + cd_commstartx;
	v_pline(gl_scrhandle, 2, pxy);

	v_gtext(gl_scrhandle, pxy[0] + gl_charwide, rasy, item->Comments);

	cd_display_color(NULL);
	st_mouse_show();
	st_v_clip_boxoff(drawrect);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_select_item(item, drawrect)
register ITEM	*item;
register GRECT	*drawrect;
{
register long	liny;
register int	rasy;
register int	hite;
int	pxy[4];

	if (item->Settings & IT_LAST)
		return;

	if (!(item->Settings & IT_SELECTED))
		return;

	liny = cd_y_coordinate(item) - cd_visy;
	hite = item->Hite;

	if ((liny < 0L) || (liny > (cd_datarect.g_h + hite)))
		return;

	rasy = cd_datarect.g_y + (int)liny;

	pxy[0] = cd_datarect.g_x + item->StartX - (int)cd_visx;
	pxy[2] = cd_datarect.g_x + cd_datarect.g_w - 1;

	pxy[1] = rasy - hite;
	pxy[3] = rasy - 1;

	st_v_clip_boxon(drawrect);
	vswr_mode(gl_scrhandle, MD_XOR);
	st_mouse_hide();

	vsf_color(gl_scrhandle, BLACK);

	pxy[0] += 1;
	pxy[3] -= 1;
	vr_recfl(gl_scrhandle, pxy);

	vsf_color(gl_scrhandle, WHITE);

	vsl_udsty(gl_scrhandle, ((pxy[0] % 2) ? cd_oddlinetype : cd_evnlinetype));
	vsl_type(gl_scrhandle, 7);

	pxy[3] += 1;
	pxy[1] = pxy[3];
	v_pline(gl_scrhandle, 2, pxy);

	vsl_type(gl_scrhandle, 1);

	st_mouse_show();
	vswr_mode(gl_scrhandle, MD_REPLACE);
	st_v_clip_boxoff(drawrect);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

long	cd_y_coordinate(pos_item)
register ITEM	*pos_item;
{
register ITEM	*item;
register long	liny;
register unsigned int	settings;

	cd_sessno = 0;
	cd_trakno = 0;
	cd_itemno = 0;

	liny = 0L;
	for (item = gl_actdocu->FirstItem ; item ; item = item->next)
	{
		settings = item->Settings;

		     if (settings & IT_SESSION)	cd_sessno ++;
		else if (settings & IT_TRACK)	cd_trakno ++;
		else if (settings & IT_ITEM)	cd_itemno ++;

		liny += item->Hite;
		if (item == pos_item)		break;
	}
	cd_sessno --;
	return(liny);
}

/* -----------------------------------------------------------------------------
 */

long	cd_inv_coordinate(tempy)
register long	tempy;
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register long	liny;

	liny = 0L;
	for (item = docu->FirstItem ; item ; item = item->next)
	{
		liny += item->Hite;
		if (liny >= tempy)	break;
	}
	cd_inv_item = ((item == NULL) ? docu->LastItem : item);
	return(liny);
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_deselect()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register long	miny;
register long	maxy;
register long	liny;
register long	tmpy;

	miny = cd_visy;
	maxy = miny + (long)(cd_datarect.g_h - 1);

	liny = 0L;
	for (item = docu->FirstItem ; item != docu->LastItem ; item = item->next)
	{
		tmpy = liny;
		liny += item->Hite;

		if (!(item->Settings & IT_SELECTED))
			continue;

		if ((liny >= miny) && (tmpy <= maxy))
		{
			cd_select_item(item, &cd_datarect);
		}
		item->Settings &= ~IT_SELECTED;
	}
	docu->NoSelItems = 0;
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_select_all()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register long	miny;
register long	maxy;
register long	liny;
register long	tmpy;

	miny = cd_visy;
	maxy = miny + (long)(cd_datarect.g_h - 1);

	liny = 0L;
	for (item = docu->FirstItem ; item != docu->LastItem ; item = item->next)
	{
		tmpy = liny;
		liny += item->Hite;

		if (item->Settings & IT_SELECTED)
			continue;

		item->Settings |= IT_SELECTED;
		if ((liny >= miny) && (tmpy <= maxy))
		{
			cd_select_item(item, &cd_datarect);
		}
	}
	docu->NoSelItems = docu->NoSessions + docu->NoTracks + docu->NoItems;
	cd_setmenu_select();
	return;
}

/******************************************************************************/
/* End of CD_DISP.C							      */
/******************************************************************************/
