.include	'jaguar.inc'

	.globl	VideoIni

; Note that the horizontal timing numbers are for NTSC

;vclk		equ	400	; this for 25 MHz
;vclk		equ	399	; this for 25.05 MHz
vclk		equ	376	; this for 26.6 MHz

; The following are time in units of 100 ps

horiz_per	equ	317778 	; 63.5555us/2 Horizontal period
sync_per	equ	46050	; 4.605us sync width
eq_per		equ	23500	; 2.35us equalization
front_porch	equ	17450	; 1.745us 
line_blank	equ	109500	; 10.95us Total blanking

; This is the display width in video clocks

disp_width	equ	1000	;this is in pixels*divider
disp_height	equ	200	;this is in lines

; Horizontal computations

n_hp		equ	horiz_per/vclk
n_hbb		equ	((horiz_per-sync_per-front_porch)/vclk)|$400
n_hbe		equ	(line_blank-sync_per-front_porch)/vclk
n_hs		equ	((horiz_per-sync_per)/vclk)|$400
n_hvs		equ	(horiz_per-(2*sync_per))/vclk
n_heq		equ	(horiz_per-eq_per)/vclk
n_hde		equ	((disp_width/2)-1)|$400
n_hdb1		equ	((n_hp)-(disp_width/2))
n_hdb2		equ	n_hdb1

; Vertical

n_vp		equ	523
n_vee		equ	6
n_vbe		equ	40
n_vdb		equ	n_vbe+26
n_vde		equ	n_vdb+(disp_height*2)
n_vbb		equ	n_vde+40
n_vs		equ	n_vp-10
n_veb		equ	n_vs-n_vee

VideoIni:
	move.w	#n_hp,HP
	move.w	#n_hbb,HBB
	move.w	#n_hbe,HBE
	move.w	#n_hs,HS
	move.w	#n_hvs,HVS
	move.w	#n_heq,HEQ
	move.w	#n_hde,HDE
	move.w	#n_hdb1,HDB1
	move.w	#n_hdb2,HDB2

	move.w	#n_vp,VP
	move.w	#n_vee,VEE
	move.w	#n_vbe,VBE
	move.w	#n_vdb,VDB
	move.w	#n_vde,VDE
	move.w	#n_vbb,VBB
	move.w	#n_veb,VEB
	move.w	#n_vs,VS

; Also lets set up some default colors

	move.w	#$f0ff,BG
	move.l	#$ffffffff,BORD1

	rts

