;************************************************************************
;* TITLE	: OBJECTS.S						*
;* Function	: Objects Used by CD+G Stuff				*
;*									*
;* Project #	: JAGUAR CD+G						*
;* Programmer	: Pradip K Fatehpuria	06/17/94			*
;*									*
;* COPYRIGHT(c) 1992,1993 Atari Computer Corporation			*
;* UNATHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION, PERFORMANCE OR	*
;* DISPLAY OF THIS COMPUTER PROGRAM OR THE ASSOCIATED AUDIOVISUAL WORK	*
;* IS STRICTLY PROHIBITED.						*
;* ALL RIGHTS RESERVED.							*
;************************************************************************

;*======================================================================*
;* HEADER FILES								*
;*======================================================================*

	.include "objlist.inc"
	.include "video.inc"
	.include "pack.inc"

;*======================================================================*
;* EXTERNAL DATA							*
;*======================================================================*

	.extern screnmem
	.extern	tvdspmem
	.extern	lndspmem

;*======================================================================*
;* PUBLIC DATA								*
;*======================================================================*

	.globl	Objects

;************************************************************************
;*	CONSTANT DATA AREA						*
;************************************************************************

	.data

;*======================================================================*
;*======================================================================*

		.phrase

Objects:	.dc.w	3			; Number of objects in list
;*
;* SCREEN OBJECT
;*
		.dc.w	0			; o_xpos	
		.dc.w	SCRNTOP			; o_ypos
		.dc.l	screnmem		; o_data
		.dc.w	200			; o_height
		.dc.w	96		; 384	; o_dwidth (width/(64/bits per pixel))
		.dc.w	96		; 384	; o_iwidth (width/(64/bits per pixel))
		.dc.b	0			; o_flags
		.dc.b	0			; o_firstpix
		.dc.b	BITOBJ			; o_type	unScaled Bit Mapped type
		.dc.b	4			; o_depth	4 bits per pixel
		.dc.b	1			; o_pitch
		.dc.b	0			; o_index
		.dc.w	0			; o_desc
		.dc.w	$0020			; unused byte, remainder = 1.0 (3.5 format)
		.dc.w	$2020			; vscale = 1.0 (3.5 format), hscale = 1.0 (3.5 format)
		.dc.l	0			; o_rom
		.dc.l	M_ACTIVE		; mode flags

;*
;* CD+G SCREEN OBJECT - CENTERED ON THE SCREEN (TV-GRAPHICS MODE)
;*
		.dc.w	48			; o_xpos
		.dc.w	SCRNTOP+(4*2)		; o_ypos
		.dc.l	tvdspmem		; o_data
		.dc.w	192			; o_height
		.dc.w	40		; 320	; o_dwidth (width/(64/bits per pixel))
		.dc.w	36		; 288	; o_iwidth (width/(64/bits per pixel))
		.dc.b	0			; o_flags
		.dc.b	0			; o_firstpix
		.dc.b	(BITOBJ | DELETE_OBJ)	; o_type	unScaled Bit Mapped type
		.dc.b	3			; o_depth	8 bits per pixel
		.dc.b	1			; o_pitch
		.dc.b	0			; o_index
		.dc.w	0			; o_desc
		.dc.w	$0020			; unused byte, remainder = 1.0 (3.5 format)
		.dc.w	$2020			; vscale = 1.0 (3.5 format), hscale = 1.0 (3.5 format)
		.dc.l	0			; o_rom
		.dc.l	M_ACTIVE		; mode flags
;*
;* CD+G SCREEN OBJECT - TOWARDS THE BOTTOM OF THE SCREEN (LINE-GRAPHICS MODE)
;*                      LIKE SUBTITLES ON THE SCREEN
;*
		.dc.w	48			; o_xpos	
		.dc.w	SCRNTOP+(152*2)		; o_ypos
		.dc.l	lndspmem		; o_data
		.dc.w	24			; o_height
		.dc.w	80		; 320	; o_dwidth (width/(64/bits per pixel))
		.dc.w	72		; 288	; o_iwidth (width/(64/bits per pixel))
		.dc.b	0			; o_flags
		.dc.b	0			; o_firstpix
		.dc.b	(BITOBJ | DELETE_OBJ)	; o_type	unScaled Bit Mapped type
		.dc.b	4			; o_depth	16 bits per pixel
		.dc.b	1			; o_pitch
		.dc.b	0			; o_index
		.dc.w	0			; o_desc
		.dc.w	$0020			; unused byte, remainder = 1.0 (3.5 format)
		.dc.w	$2020			; vscale = 1.0 (3.5 format), hscale = 1.0 (3.5 format)
		.dc.l	0			; o_rom
		.dc.l	M_ACTIVE		; mode flags

		.phrase

;************************************************************************
;* END OF FILE								*
;************************************************************************

	.end

