;*======================================================================*
;* TITLE	: JOYPAD.INC						*
;* Function	: Joypad bit definitions				*
;*									*
;* Project #	: JAGUAR						*
;* Programmer	: Rob Zdybel						*
;*									*
;* MODIFIED	: Andrew J Burgess	04/13/93			*
;*		  Pradip K Fatehpuria	10/27/93			*
;*									*
;* COPYRIGHT 1993 Atari Computer Corporation				*
;* UNATHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION, PERFORMANCE OR	*
;* DISPLAY OF THIS COMPUTER PROGRAM OR THE ASSOCIATED AUDIOVISUAL WORK	*
;* IS STRICTLY PROHIBITED.						*
;* ALL RIGHTS RESERVED.							*
;*									*
;*======================================================================*

NUM_PLAYERS	EQU	1

;*======================================================================*
;*	JOYPAD REGISTERS						*
;*======================================================================*

; BASE		EQU	$F00000

JOYIN		EQU	BASE + $14000
JOYOUT		EQU	BASE + $14000

;*======================================================================*
;*	FORMAT = xxAPxxBx RLDU147* xxCxxxOx 2580369#			*
;*======================================================================*

JOY_UP		EQU	20		; joypad directions
JOY_DOWN	EQU	21
JOY_LEFT	EQU	22
JOY_RIGHT	EQU	23

FIRE_A		EQU	29		; fire buttons
FIRE_B		EQU	25
FIRE_C		EQU	13

OPTION		EQU	9		; options button
PAUSE		EQU	28		; pause button

KEY_STAR	EQU	16		; numerical keypad
KEY_7		EQU	17
KEY_4		EQU	18
KEY_1		EQU	19

KEY_0		EQU	4
KEY_8		EQU	5
KEY_5		EQU	6
KEY_2		EQU	7

KEY_HASH	EQU	0
KEY_9		EQU	1
KEY_6		EQU	2
KEY_3		EQU	3

;*======================================================================*

ANY_JOY		EQU	$00F00000	; and joyedge with this - joypad
					; was pressed if result is not 0

ANY_FIRE	EQU	$32002200	; and joyedge with this - A,B C,
					; Option or Pausewas pressed if
					; result is not 0

ANY_KEY		EQU	$000F00FF	; and joyedge with this -
					; 23456789*0# was pressed if
					; result is not 0

;*======================================================================*
;* EOF									*
;*======================================================================*
